(function($) {

  var info = {};
  var ie6 = $.browser.msie && /MSIE 6.0/.test(navigator.userAgent);

  $.fn.views_rotator = function(options) {
    return this.each(function() {   
      $.views_rotator(this, options);
    });
  };
  
  $.views_rotator = function(container, options) {
    var settings = {
      'transition_time':    'normal',
      'interval_time':      2000,
      'area_height':        'auto',
      'vclass':             'views_rotator',
      'children':           null,
      'mouseover_pause':    0,
      'back_next_buttons':  0
    };
    if (options)
      $.extend(settings, options);
    if (settings.children === null)
      var elements = $(container).children();
    else
      var elements = $(container).children(settings.children);
    if (elements.length > 1) {
      info[settings.id] = {
        'current': 1,
        'last': 0
      }
      $(container).css('position', 'relative').css('height', settings.area_height).addClass(settings.vclass);
      for (var i = 0; i < elements.length; i++) {
        $(elements[i]).css('z-index', String(elements.length-i)).css('position', 'absolute').hide();
      };
      info[settings.id].timeoutID = setTimeout(function() {
        $.views_rotator.next(elements, settings);
      }, settings.interval_time);
      $(elements[0]).show();
      if (settings.mouseover_pause == 1) {
        $('.' + settings.id).mouseout(function() {
          if (typeof(info[settings.id].timeoutID) != 'undefined') {
            clearTimeout(info[settings.id].timeoutID);
            delete info[settings.id].timeoutID;
          }
          info[settings.id].timeoutID = setTimeout((function() {
            $.views_rotator.next(elements, settings);
          }), settings.interval_time);
          if (settings.back_next_buttons == 1) {
            $('.' + settings.id + ' .views-rotator-prev').removeClass('views-rotator-prev-hover');
            $('.' + settings.id + ' .views-rotator-next').removeClass('views-rotator-next-hover');
          }
        }).mouseover(function() {
          if (typeof(info[settings.id].timeoutID) != 'undefined') {
            clearTimeout(info[settings.id].timeoutID);
            delete info[settings.id].timeoutID;
          }
          if (settings.back_next_buttons == 1) {
            $('.' + settings.id + ' .views-rotator-prev').addClass('views-rotator-prev-hover');
            $('.' + settings.id + ' .views-rotator-next').addClass('views-rotator-next-hover');
          }
        });
      }
      else if (settings.back_next_buttons == 1) {
        $('.' + settings.id).mouseover(function() {
          $('.' + settings.id + ' .views-rotator-prev').addClass('views-rotator-prev-hover');
          $('.' + settings.id + ' .views-rotator-next').addClass('views-rotator-next-hover');
        }).mouseout(function() {
          $('.' + settings.id + ' .views-rotator-prev').removeClass('views-rotator-prev-hover');
          $('.' + settings.id + ' .views-rotator-next').removeClass('views-rotator-next-hover');
        });
      }
      if (settings.back_next_buttons == 1) {
        $(container).parent().css('height', settings.area_height);
        $('.' + settings.id).prepend('<div class="views-rotator-prev"><a></a></div><div class="views-rotator-next"><a></a></div>');
        $('.' + settings.id + ' .views-rotator-prev a').click(function() {
          var current = info[settings.id].current;
          var last = info[settings.id].last;
          if ((last - 1) < 0) {
            current = elements.length - 1;
          } else {
            current = last - 1;
          }
          // Fix IE6/Cleartype bug
          if (ie6) {
            $.views_rotator.clearTypeFix($(elements[last]));
            $.views_rotator.clearTypeFix($(elements[current]));
          }
          $(elements[last]).fadeOut(settings.transition_time, function() {
            // Work around IE/cleartype bug
            if(this.style.removeAttribute){
              this.style.removeAttribute('filter');
            }
          });
          $(elements[current]).fadeIn(settings.transition_time, function() {
            // Work around IE/cleartype bug
            if(this.style.removeAttribute){
              this.style.removeAttribute('filter');
            }
          });
          if ((current + 1) < elements.length) {
            current = current + 1;
            last = current - 1;
          } else {
            current = 0;
            last = elements.length - 1;
          }
          info[settings.id].current = current;
          info[settings.id].last = last;
        });
        $('.' + settings.id + ' .views-rotator-next a').click(function() {
          var current = info[settings.id].current;
          var last = info[settings.id].last;
          // Fix IE6/Cleartype bug
          if (ie6) {
            $.views_rotator.clearTypeFix($(elements[last]));
            $.views_rotator.clearTypeFix($(elements[current]));
          }
          $(elements[last]).fadeOut(settings.transition_time, function() {
            // Work around IE/cleartype bug
            if(this.style.removeAttribute){
              this.style.removeAttribute('filter');
            }
          });
          $(elements[current]).fadeIn(settings.transition_time, function() {
            // Work around IE/cleartype bug
            if(this.style.removeAttribute){
              this.style.removeAttribute('filter');
            }
          });
          if ((current + 1) < elements.length) {
            current = current + 1;
            last = current - 1;
          } else {
            current = 0;
            last = elements.length - 1;
          }
          info[settings.id].current = current;
          info[settings.id].last = last;
        });
      }
		}
  };

  $.views_rotator.next = function(elements, settings) {
    var current = info[settings.id].current;
    var last = info[settings.id].last;
    // Fix IE6/Cleartype bug
    if (ie6) {
      $.views_rotator.clearTypeFix($(elements[last]));
      $.views_rotator.clearTypeFix($(elements[current]));
    }
    $(elements[last]).fadeOut(settings.transition_time, function() {
      // Work around IE/cleartype bug
      if(this.style.removeAttribute){
        this.style.removeAttribute('filter');
      }
    });
    $(elements[current]).fadeIn(settings.transition_time, function() {
			// Work around IE/cleartype bug
      if(this.style.removeAttribute){
        this.style.removeAttribute('filter');
      }
		});
    if ((current + 1) < elements.length) {
      current = current + 1;
      last = current - 1;
    } else {
      current = 0;
      last = elements.length - 1;
    }
    info[settings.id].current = current;
    info[settings.id].last = last;
    if (typeof(info[settings.id].timeoutID) != 'undefined') {
      clearTimeout(info[settings.id].timeoutID);
      delete info[settings.id].timeoutID;
    }
    info[settings.id].timeoutID = setTimeout((function() {
      $.views_rotator.next(elements, settings);
    }), settings.interval_time);
  }
  
  // this fixes clearType problems in ie6 by setting an explicit bg color
  $.views_rotator.clearTypeFix = function(elements) {
    function hex(s) {
        var s = parseInt(s).toString(16);
        return s.length < 2 ? '0'+s : s;
    };
    function getBg(e) {
        for ( ; e && e.nodeName.toLowerCase() != 'html'; e = e.parentNode) {
            var v = $.css(e,'background-color');
            if (v.indexOf('rgb') >= 0 ) { 
                var rgb = v.match(/\d+/g); 
                return '#'+ hex(rgb[0]) + hex(rgb[1]) + hex(rgb[2]);
            }
            if (v && v != 'transparent')
                return v;
        }
        return '#ffffff';
    };
    elements.each(function() {
      $(this).css('background-color', getBg(this)); 
    });
  };
  
})(jQuery);

if (Drupal.jsEnabled) {
  $(document).ready(function() {
    $.each(Drupal.settings.views_rotator, function() {
      $('#' + this.id).views_rotator(this);
      if (this.auto_height == 1) {
        var height = null;
        $('#' + this.id + ' li').each(function() {
          var item_height = $(this).height();
          if (item_height > height) height = item_height;
        });
        $('#' + this.id).height(height);
      }
    });
  });
};